{
  open Cnf;;
  open Lexing;;
  open Fof_parse;;
}

let white = [' ' '\t' '\r' '\n']
let letter = ['/' 'a'-'z' 'A'-'Z' '0'-'9' '_' '-']
let letterdot = ['/' 'a'-'z' 'A'-'Z' '0'-'9' '_' '-' '.']
let any = [^ '\r' '\n']

rule hhlex = parse
| '%' any*           {hhlex lexbuf}
| '#' any*           {hhlex lexbuf}
| white+             {hhlex lexbuf}
| eof                {Eof}
| '('                {Openp}
| ')'                {Closep}
| '.'                {Dot}
| ','                {Comma}
| '!' white* '['     {All (lex_ids lexbuf)}
| '?' white* '['     {Ex (lex_ids lexbuf)}
| '='                {Eq}
| "!="               {Neq}
| '~'                {Tilde}
| "<=>"              {Eqvt}
| "<~>"              {Neqvt}
| "=>"               {Impl}
| "<="               {Revimpl}
| '&'                {And}
| '|'                {Or}
| '$' letter+        {Word (Lexing.lexeme lexbuf)}
| letter letterdot*  {let s = Lexing.lexeme lexbuf in Word (if s = "#" then "'#'" else s) }

and lex_ids = parse
| white+             {lex_ids lexbuf}
| letter+            {let i = Lexing.lexeme lexbuf in i :: (lex_ids_more lexbuf)}

and lex_ids_more = parse
| white+             {lex_ids_more lexbuf}
| ','                {lex_ids lexbuf}
| ']' white* ':'     {[]}

{}
